package kernel.http;

using lua.Table;

class HTTPFailure {

	public final reason:String;
	public final statusCode:Null<StatusCode>;
	public final headers:Map<String,String>;
	public final body:String;

	@:allow(kernel.http)
	private function new(failReason: String, ?handle: cc.HTTP.HTTPResponse) {
		this.reason = failReason;
		if (handle != null){
			this.statusCode = handle.getResponseCode();
			this.headers = handle.getResponseHeaders().toMap();
			this.body = handle.readAll();
			handle.close();
		}
	}
}
